



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>基于spark的plsa实现</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">基于spark的plsa实现</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-29 15:03:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>PLSA.py</h2>
<div>
<pre class="prettyprint linenums"> # coding:utf8<br />
 from pyspark import SparkContext<br />
 from pyspark import RDD<br />
 import numpy as np<br />
 from numpy.random import RandomState

 import sys<br />
 reload(sys)<br />
 #设置默认编码为utf8，从spark rdd中取出中文词汇时需要编码为中文编码，否则不能保存成功<br />
 sys.setdefaultencoding('utf8')

 """<br />
 总结：<br />
 broadcast变量和需要用到broadcast变量的方法需要位于同一作用域

 broadcast变量的unpersist会将存储broadcast变量的文件立即删除，<br />
     而此时rdd并未被触发执行，当rdd执行时会发现没有broadcast变量，所以会报错，<br />
     建议只在程序运行完成后，将broadcast变量 unpersist<br />
 """

 class PLSA:

     def __init__(self, data, sc, k, is_test=False, max_itr=1000, eta=1e-6):

         """<br />
         init the algorithm

         :type data RDD<br />
         :param data: 输入文章rdd，每条记录为一系列用空格分隔的词，如"我 爱 蓝天 我 爱 白云"<br />
         :type max_itr int<br />
         :param max_itr: 最大EM迭代次数<br />
         :type is_test bool<br />
         :param is_test: 是否为测试,是则rd = RandomState(1)，否则 rd = RandomState()<br />
         :type sc SparkContext<br />
         :param sc: spark context<br />
         :type k int<br />
         :param k : 主题个数<br />
         :type eta float<br />
         :param : 阈值，当log likelyhood的变化小于eta时，停止迭代<br />
         :return : PLSA object<br />
         """<br />
         self.max_itr = max_itr<br />
         self.k = sc.broadcast(k)<br />
         self.ori_data = data.map(lambda x: x.split(' '))<br />
         self.sc = sc<br />
         self.eta = eta

         self.rd = sc.broadcast(RandomState(1) if is_test else RandomState())

     def train(self):

         #获取词汇字典 ，如{"我":1}<br />
         self.word_dict_b = self._init_dict_()<br />
         #将文本中词汇，转成词典中的index<br />
         self._convert_docs_to_word_index()<br />
         #初始化，每个主题下的单词分布<br />
         self._init_probility_word_topic_()

         pre_l= self._log_likelyhood_()

         print "L(%d)=%.5f" %(0,pre_l)

         for i in range(self.max_itr):<br />
             #更新每个单词主题的后验分布<br />
             self._E_step_()<br />
             #最大化下界<br />
             self._M_step_()<br />
             now_l = self._log_likelyhood_()

             improve = np.abs((pre_l-now_l)/pre_l)<br />
             pre_l = now_l

             print "L(%d)=%.5f with %.6f%% improvement" %(i+1,now_l,improve*100)<br />
             if improve &lt;self.eta:<br />
                 break

     def _M_step_(self):<br />
         """<br />
         更新参数 p(z=k|d),p(w|z=k)<br />
         :return: None<br />
         """<br />
         k = self.k<br />
         v = self.v

         def update_probility_of_doc_topic(doc):<br />
             """<br />
             更新文章的主题分布<br />
             """<br />
             doc['topic'] = doc['topic'] - doc['topic']

             topic_doc = doc['topic']<br />
             words = doc['words']<br />
             for (word_index,word) in words.items():<br />
                 topic_doc += word['count']*word['topic_word']<br />
             topic_doc /= np.sum(topic_doc)

             return {'words':words,'topic':topic_doc}

         self.data = self.data.map(update_probility_of_doc_topic)<br />
         """<br />
         rdd相当于一系列操作过程的结合，且前面的操作过程嵌套在后面的操作过程里，当这个嵌套超过大约60，spark会报错，<br />
         这里每次M step都通过cache将前面的操作执行掉<br />
         """<br />
         self.data.cache()

         def update_probility_word_given_topic(doc):<br />
             """<br />
             更新每个主题下的单词分布<br />
             """<br />
             probility_word_given_topic = np.matrix(np.zeros((k.value,v.value)))

             words = doc['words']<br />
             for (word_index,word) in words.items():<br />
                 probility_word_given_topic[:,word_index] += np.matrix(word['count']*word['topic_word']).T

             return probility_word_given_topic

         probility_word_given_topic = self.data.map(update_probility_word_given_topic).sum()<br />
         probility_word_given_topic_row_sum = np.matrix(np.sum(probility_word_given_topic,axis=1))

         #使每个主题下单词概率和为1<br />
         probility_word_given_topic = np.divide(probility_word_given_topic,probility_word_given_topic_row_sum)

         self.probility_word_given_topic = self.sc.broadcast(probility_word_given_topic)

     def _E_step_(self):<br />
         """<br />
         更新隐变量 p(z|w,d)-给定文章，和单词后，该单词的主题分布<br />
         :return: None<br />
         """<br />
         probility_word_given_topic = self.probility_word_given_topic<br />
         k = self.k

         def update_probility_of_word_topic_given_word(doc):<br />
             topic_doc = doc['topic']<br />
             words = doc['words']

             for (word_index,word) in words.items():<br />
                 topic_word = word['topic_word']<br />
                 for i in range(k.value):<br />
                     topic_word[i] = probility_word_given_topic.value[i,word_index]*topic_doc[i]<br />
                 #使该单词各主题分布概率和为1<br />
                 topic_word /= np.sum(topic_word)<br />
             return {'words':words,'topic':topic_doc}

         self.data = self.data.map(update_probility_of_word_topic_given_word)

     def  _init_probility_word_topic_(self):<br />
         """<br />
         init p(w|z=k)<br />
         :return: None<br />
         """<br />
         #dict length(words in dict)<br />
         m = self.v.value

         probility_word_given_topic = self.rd.value.uniform(0,1,(self.k.value,m))<br />
         probility_word_given_topic_row_sum = np.matrix(np.sum(probility_word_given_topic,axis=1)).T

         #使每个主题下单词概率和为1<br />
         probility_word_given_topic = np.divide(probility_word_given_topic,probility_word_given_topic_row_sum)

         self.probility_word_given_topic = self.sc.broadcast(probility_word_given_topic)

     def _convert_docs_to_word_index(self):

         word_dict_b = self.word_dict_b<br />
         k = self.k<br />
         rd = self.rd<br />
         '''<br />
         I wonder is there a better way to execute function with broadcast varible<br />
         '''<br />
         def _word_count_doc_(doc):<br />
             wordcount ={}<br />
             word_dict = word_dict_b.value<br />
             for word in doc:<br />
                 if wordcount.has_key(word_dict[word]):<br />
                     wordcount[word_dict[word]]['count'] += 1<br />
                 else:<br />
                     #first one is the number of word occurance<br />
                     #second one is p(z=k|w,d)<br />
                     wordcount[word_dict[word]] = {'count':1,'topic_word': rd.value.uniform(0,1,k.value)}

             topics = rd.value.uniform(0, 1, k.value)<br />
             topics = topics/np.sum(topics)<br />
             return {'words':wordcount,'topic':topics}

         self.data = self.ori_data.map(_word_count_doc_)

     def _init_dict_(self):<br />
         """<br />
         init word dict of the documents,<br />
         and broadcast it<br />
         :return: None<br />
         """<br />
         words = self.ori_data.flatMap(lambda d: d).distinct().collect()<br />
         word_dict = {w: i for w, i in zip(words, range(len(words)))}<br />
         self.v = self.sc.broadcast(len(word_dict))<br />
         return self.sc.broadcast(word_dict)

     def _log_likelyhood_(self):<br />
         probility_word_given_topic = self.probility_word_given_topic<br />
         k = self.k

         def likelyhood(doc):<br />
             l = 0.0<br />
             topic_doc = doc['topic']<br />
             words = doc['words']

             for (word_index,word) in words.items():<br />
                 l += word['count']*np.log(np.matrix(topic_doc)*probility_word_given_topic.value[:,word_index])<br />
             return l<br />
         return self.data.map(likelyhood).sum()

     def save(self,f_word_given_topic,f_doc_topic):<br />
         """<br />
         保存模型结果 TODO 添加分布式保存结果<br />
         :param f_word_given_topic: 文件路径，用于给定主题下词汇分布<br />
         :param f_doc_topic: 文件路径，用于保存文档的主题分布<br />
         :return:<br />
         """<br />
         doc_topic = self.data.map(lambda x:' '.join([str(q) for q in x['topic'].tolist()])).collect()<br />
         probility_word_given_topic = self.probility_word_given_topic.value

         word_dict = self.word_dict_b.value<br />
         word_given_topic = []

         for w,i in word_dict.items():<br />
             word_given_topic.append('%s %s' %(w,' '.join([str(q[0]) for q in probility_word_given_topic[:,i].tolist()])))

         f1 = open (f_word_given_topic, 'w')

         for line in word_given_topic:<br />
             f1.write(line)<br />
             f1.write('\n')<br />
         f1.close()

         f2 = open (f_doc_topic, 'w')

         for line in doc_topic:<br />
             f2.write(line)<br />
             f2.write('\n')<br />
         f2.close()</pre>
</div>
<h2>调用</h2>
<div>
<div>
<pre class="prettyprint linenums"> from PLSA import PLSA<br />
 from pyspark import SparkContext

 if __name__=="__main__":<br />
     sc = SparkContext('local')<br />
     data = sc.textFile("E:/github/FGYML4/data/news_seg/news_seg.txt")<br />
     plsa = PLSA(data,sc,3,max_itr=1)<br />
     plsa.train()<br />
     plsa.save('D:/topic_word','D:/doc_topic')</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1j360q.html">javap查看class文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ejonj9.html">win7 IIS7环境下部署PHP 7&period;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwwzzzq.html">TSP问题&mdash;&mdash;动态规划</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kdgzr9.html">Apache配置中的ProxyPass 和 ProxyPassReverse</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1x7l08.html">【request&lowbar;firmware】 linux内核下载模块固件接口【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zz04x8.html">commons-logging和log4j</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2pxzx8.html">重新想象 Windows 8 Store Apps &lpar;57&rpar; - 本地化和全球化</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x0ovz8.html">ARM体系的7种工作模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okdkm59.html">【BZOJ】【3676】【APIO2014】回文串</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xn0nz9.html">Delphi XE5教程6：单元的结构和语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y71vnq.html">关于B&sol;S系统中文件上传的大小限制怎么做</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xk3vv8.html">Delphi 和 DFM</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg1w7m8.html">把ipad作为电脑的第二显示器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z0el19.html">【网络爬虫入门05】分布式文件存储数据库MongoDB的基本操作与爬虫应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1knmmz9.html">Windows Server 2016-查询FSMO角色信息的三种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4ev0z9.html">电脑小白和ta的小白电脑&mdash;&mdash;Tomcat服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rkre48.html">HiveServer2的WEB UI界面</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1moze9.html">裸奔的智能插座：博联Broadlink SP2&sol;SP mini的分析、破解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv52kz8.html">react踩坑记录&mdash;&mdash;使用fetch获取json数据报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r4ldz8.html">spark streaming集成kafka</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qde7v1x9.html">MySQL存储过程事务处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okmrm59.html">【剑指offer】面试题28：字符串的排列</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv4mdzq.html">Colorful Lecture Note&lpar;手工栈）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1pzy28.html">【HDU1754】I Hate It（线段树）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mky1xq.html">Git服务器搭建全过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1px5j8.html">JAVA中的Formatter</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z17o59.html">Jquery radio checked</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdv2j78.html">Unity Navigation面板了解</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x22n68.html">RelativeLayout经常使用属性介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1xw669.html">阻止IOS自动识别页面上的电话号码、email地址</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
